diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
index f374690da..879ae2f8f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentVehicleHealthBar.java
@@ -12,17 +12,52 @@ import net.minecraft.core.util.helper.MathHelper;
 
 import java.util.Random;
 
-public class HudComponentVehicleHealthBar
-    extends HudComponentMovable {
+public class HudComponentVehicleHealthBar extends HudComponentMovable {
     private final Random random = new Random();
 
     public HudComponentVehicleHealthBar(String key, Layout layout) {
-        super(key, 81, 10, layout);
+        super(key, 81, 9, layout);
+    }
+
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_VEHICLE_BAR.value;
+    }
+
+    private boolean isFlipped() {
+        return GameSettings.FLIP_VEHICLE_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
+    @Override
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
     }
 
     @Override
     public boolean isVisible() {
-        return mc.thePlayer.vehicle instanceof Mob && GameSettings.IMMERSIVE_MODE.drawHotbar();
+        if (mc.thePlayer == null) {
+            return GameSettings.IMMERSIVE_MODE.drawHotbar();
+        }
+        return mc.thePlayer.vehicle instanceof Mob && GameSettings.IMMERSIVE_MODE.drawHotbar() && !GameSettings.HIDE_VEHICLE_BAR.value;
+    }
+
+    @Override
+    public boolean isPreviewTranslucent() {
+        return GameSettings.HIDE_VEHICLE_BAR.value;
     }
 
     @Override
@@ -43,36 +78,61 @@ public class HudComponentVehicleHealthBar
             int prevHealth = mobVehicle.prevHealth;
             this.random.setSeed(hud.updateCounter * 0x4c627L);
 
+            boolean isVertical = this.isVertical();
+            boolean isFlipped = this.isFlipped();
+
+            String halfSuffix = "";
+            if (isVertical) {
+                halfSuffix = isFlipped ? "_vertical_flipped" : "_vertical";
+            } else if (isFlipped) {
+                halfSuffix = "_flipped";
+            }
+
             int hearts = MathHelper.ceil(mobVehicle.getMaxHealth() / 2f);
+            String basePath = "minecraft:gui/hud/heart/vehicle/pig/";
+
             for (int i = 0; i < hearts; i++) {
                 int heartOffset = 0;
                 if (heartsFlash) {
                     heartOffset = 1;
                 }
-                int xHeart = (x + 9 * 8) - i * 8;
-                int yHeart = y;
-                if (health <= 4) {
-                    yHeart += this.random.nextInt(2);
+
+                int xHeart;
+                int yHeart;
+
+                if (isVertical) {
+                    xHeart = x;
+                    yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+                    if (health <= 4) {
+                        xHeart += this.random.nextInt(2); // Shake horizontally
+                    }
+                } else {
+                    xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                    yHeart = y;
+                    if (health <= 4) {
+                        yHeart += this.random.nextInt(2); // Shake vertically
+                    }
                 }
 
-                hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container_blinking"));
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture(basePath + "container") : TextureRegistry.getTexture(basePath + "container_blinking"));
+
                 if (heartsFlash) {
                     if (i * 2 + 1 < prevHealth) {
                         // Half flash heart icon
-                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full_blinking"));
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "full_blinking"));
                     }
                     if (i * 2 + 1 == prevHealth) {
                         // Full flash heart icon
-                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half_blinking"));
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "half_blinking" + halfSuffix));
                     }
                 }
                 if (i * 2 + 1 < health) {
                     // Full heart icon
-                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "full"));
                 }
                 if (i * 2 + 1 == health) {
                     // Half heart icon
-                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "half" + halfSuffix));
                 }
             }
         }
@@ -85,20 +145,44 @@ public class HudComponentVehicleHealthBar
 
         // Setup rendering
         GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        renderTranslucency();
         GLRenderer.enableState(State.BLEND);
 
         int health = 11;
+        boolean isVertical = this.isVertical();
+        boolean isFlipped = this.isFlipped();
+
+        String halfSuffix = "";
+        if (isVertical) {
+            halfSuffix = isFlipped ? "_vertical_flipped" : "_vertical";
+        } else if (isFlipped) {
+            halfSuffix = "_flipped";
+        }
+
+        String basePath = "minecraft:gui/hud/heart/vehicle/pig/";
+
         for (int i = 0; i < 10; i++) {
-            int xHeart = (x + 9 * 8) - i * 8;
-            gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/container"));
+            int xHeart;
+            int yHeart;
+
+            if (isVertical) {
+                xHeart = x;
+                yHeart = isFlipped ? (y + i * 8) : (y + (9 - i) * 8);
+            } else {
+                xHeart = isFlipped ? (x + (9 - i) * 8) : (x + i * 8);
+                yHeart = y;
+            }
+
+            gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "container"));
+
             if (i * 2 + 1 < health) {
                 // Full heart icon
-                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/full"));
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "full"));
             }
             if (i * 2 + 1 == health) {
                 // Half heart icon
-                gui.drawGuiIcon(xHeart, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/pig/half"));
+                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture(basePath + "half" + halfSuffix));
             }
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 4edc6090a..6dbdda565 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -3,6 +3,11 @@ package net.minecraft.client.gui.hud.component;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.gui.options.components.BooleanOptionComponent;
+import net.minecraft.client.gui.options.components.KeyBindingComponent;
+import net.minecraft.client.gui.options.components.ToggleableOptionComponent;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.core.enums.HumanArmorShape;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -16,35 +21,114 @@ public class HudComponents {
     public static String DEFAULT_LAYOUT = null;
     public static final @Nullable HudComponents INSTANCE = new HudComponents();
 
-    public static final @NotNull HudComponent HOTBAR = register(new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER)));
-    public static final @NotNull HudComponent CROSSHAIR = register(new HudComponentCrosshair("crosshair", new LayoutAbsolute(0.5f, 0.5f, ComponentAnchor.CENTER)));
-    public static final @NotNull HudComponent HEALTH_BAR = register(new HudComponentHealthBar("health_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final @NotNull HudComponent ARMOR_BAR = register(new HudComponentArmorBar("armor_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final @NotNull HudComponent VEHICLE_BAR = register(new HudComponentVehicleHealthBar("vehicle_bar", new LayoutSnap(ARMOR_BAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final @NotNull HudComponent OXYGEN_BAR = register(new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final @NotNull HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
-    public static final @NotNull HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final @NotNull HudComponent SUBTITLES = register(new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
-    public static final @NotNull HudComponent LOG = register(new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT)));
-    public static final @NotNull HudComponent ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
-    public static final @NotNull HudComponent HELD_ITEM_COUNT = register(new HudComponentHeldItemCount("held_item_count", new LayoutSnap(HOTBAR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
-    public static final @NotNull HudComponent INFO_OVERLAY = register(new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT)));
+    // Absolute components
+    public static final @NotNull HudComponentHotbar HOTBAR = register(
+        new HudComponentHotbar("hotbar", new LayoutAbsolute(0.5f, 1.0f, ComponentAnchor.BOTTOM_CENTER, 0, -2))
+            .addAttachedOption(GameSettings.VERTICAL_HOT_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_HOT_BAR))
+    );
+    public static final @NotNull HudComponentCrosshair CROSSHAIR = register(
+        new HudComponentCrosshair("crosshair", new LayoutAbsolute(0.5f, 0.5f, ComponentAnchor.CENTER))
+    );
+    public static final @NotNull HudComponentSubtitles SUBTITLES = register(
+        new HudComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT))
+    );
+    public static final @NotNull HudComponentLog LOG = register(
+        new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT))
+    );
 
-    public static HudComponent register(HudComponent component) {
+    // public static final @NotNull HudComponentArmorDurability ARMOR_DURABILITY = register(new HudComponentArmorDurability("armor_durability", new LayoutAbsolute(0.0f, 1.0f, ComponentAnchor.BOTTOM_LEFT)));
+
+    public static final @NotNull HudComponentInfoOverlay INFO_OVERLAY = register(
+        new HudComponentInfoOverlay("info_overlay", new LayoutAbsolute(0.0f, 0.0f, ComponentAnchor.TOP_LEFT))
+            .addAttachedOption(GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT))
+            .addAttachedOption(GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT, () -> new ToggleableOptionComponent<>(GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT))
+            .addAttachedOption(GameSettings.VERSION_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.VERSION_IN_OVERLAY))
+            .addAttachedOption(GameSettings.FPS_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.FPS_IN_OVERLAY))
+            .addAttachedOption(GameSettings.COORDS_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.COORDS_IN_OVERLAY))
+            .addAttachedOption(GameSettings.DIRECTION_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.DIRECTION_IN_OVERLAY))
+            .addAttachedOption(GameSettings.TIME_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.TIME_IN_OVERLAY))
+            .addAttachedOption(GameSettings.SEASON_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.SEASON_IN_OVERLAY))
+            .addAttachedOption(GameSettings.WEATHER_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.WEATHER_IN_OVERLAY))
+            .addAttachedOption(GameSettings.BIOME_IN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.BIOME_IN_OVERLAY))
+            .addAttachedKeyBinding(GameSettings.KEY_TOGGLE_INFO_OVERLAY, () -> new KeyBindingComponent(GameSettings.KEY_TOGGLE_INFO_OVERLAY))
+    );
+
+    // Snapped components
+    public static final @NotNull HudComponentDynamicTooltip DYNAMIC_TOOLTIP = register(
+        new HudComponentDynamicTooltip("dynamic_tooltip", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_CENTER, ComponentAnchor.BOTTOM_CENTER, 0, -29))
+            .addAttachedOption(GameSettings.HIDE_DYNAMIC_TOOLTIP, () -> new BooleanOptionComponent(GameSettings.HIDE_DYNAMIC_TOOLTIP))
+    );
+    public static final @NotNull HudComponentHealthBar HEALTH_BAR = register(
+        new HudComponentHealthBar("health_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT, 0, -1))
+            .addAttachedOption(GameSettings.FOOD_HEALTH_REGEN_OVERLAY, () -> new BooleanOptionComponent(GameSettings.FOOD_HEALTH_REGEN_OVERLAY))
+            .addAttachedOption(GameSettings.HIDE_HEALTH_BAR, () -> new BooleanOptionComponent(GameSettings.HIDE_HEALTH_BAR))
+            .addAttachedOption(GameSettings.VERTICAL_HEALTH_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_HEALTH_BAR))
+            .addAttachedOption(GameSettings.FLIP_HEALTH_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_HEALTH_BAR))
+    );
+    public static final @NotNull HudComponentArmorBar BOOTS_BAR = register(
+        new HudComponentArmorBar("boots_bar", new LayoutSnap(HOTBAR, ComponentAnchor.TOP_RIGHT, ComponentAnchor.BOTTOM_RIGHT, 0, -1), HumanArmorShape.BOOTS)
+            .addAttachedOption(GameSettings.HIDE_BOOTS_BAR, () -> new ToggleableOptionComponent<>(GameSettings.HIDE_BOOTS_BAR))
+            .addAttachedOption(GameSettings.FLIP_BOOTS_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_BOOTS_BAR))
+    );
+    public static final @NotNull HudComponentArmorBar LEGGINGS_BAR = register(
+        new HudComponentArmorBar("leggings_bar", new LayoutSnap(BOOTS_BAR, ComponentAnchor.CENTER_LEFT, ComponentAnchor.CENTER_RIGHT, -3, 0), HumanArmorShape.LEGS)
+            .addAttachedOption(GameSettings.HIDE_LEGGINGS_BAR, () -> new ToggleableOptionComponent<>(GameSettings.HIDE_LEGGINGS_BAR))
+            .addAttachedOption(GameSettings.FLIP_LEGGINGS_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_LEGGINGS_BAR))
+    );
+
+    public static final @NotNull HudComponentArmorBar CHESTPLATE_BAR = register(
+        new HudComponentArmorBar("chestplate_bar", new LayoutSnap(LEGGINGS_BAR, ComponentAnchor.CENTER_LEFT, ComponentAnchor.CENTER_RIGHT, -3, 0), HumanArmorShape.CHEST)
+            .addAttachedOption(GameSettings.HIDE_CHESTPLATE_BAR, () -> new ToggleableOptionComponent<>(GameSettings.HIDE_CHESTPLATE_BAR))
+            .addAttachedOption(GameSettings.FLIP_CHESTPLATE_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_CHESTPLATE_BAR))
+    );
+    public static final @NotNull HudComponentArmorBar HELMET_BAR = register(
+        new HudComponentArmorBar("helmet_bar", new LayoutSnap(CHESTPLATE_BAR, ComponentAnchor.CENTER_LEFT, ComponentAnchor.CENTER_RIGHT, -3, 0), HumanArmorShape.HEAD)
+            .addAttachedOption(GameSettings.HIDE_HELMET_BAR, () -> new ToggleableOptionComponent<>(GameSettings.HIDE_HELMET_BAR))
+            .addAttachedOption(GameSettings.FLIP_HELMET_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_HELMET_BAR))
+    );
+    public static final @NotNull HudComponentVehicleHealthBar VEHICLE_BAR = register(
+        new HudComponentVehicleHealthBar("vehicle_bar", new LayoutSnap(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT, 0, -1))
+            .addAttachedOption(GameSettings.HIDE_VEHICLE_BAR, () -> new BooleanOptionComponent(GameSettings.HIDE_VEHICLE_BAR))
+            .addAttachedOption(GameSettings.VERTICAL_VEHICLE_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_VEHICLE_BAR))
+            .addAttachedOption(GameSettings.FLIP_VEHICLE_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_VEHICLE_BAR))
+    );
+    public static final @NotNull HudComponentOxygenBar OXYGEN_BAR = register(
+        new HudComponentOxygenBar("oxygen_bar", new LayoutSnap(VEHICLE_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT,0, -1))
+            .addAttachedOption(GameSettings.HIDE_OXYGEN_BAR, () -> new BooleanOptionComponent(GameSettings.HIDE_OXYGEN_BAR))
+            .addAttachedOption(GameSettings.VERTICAL_OXYGEN_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_OXYGEN_BAR))
+            .addAttachedOption(GameSettings.FLIP_OXYGEN_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_OXYGEN_BAR))
+    );
+    public static final @NotNull HudComponentFireBar FIRE_BAR = register(
+        new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT, 0, -1))
+            .addAttachedOption(GameSettings.HIDE_FIRE_BAR, () -> new BooleanOptionComponent(GameSettings.HIDE_FIRE_BAR))
+            .addAttachedOption(GameSettings.VERTICAL_FIRE_BAR, () -> new BooleanOptionComponent(GameSettings.VERTICAL_FIRE_BAR))
+            .addAttachedOption(GameSettings.FLIP_FIRE_BAR, () -> new BooleanOptionComponent(GameSettings.FLIP_FIRE_BAR))
+    );
+    public static final @NotNull HudComponentRotationLock ROTATION_LOCK = register(
+        new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT))
+            .addAttachedKeyBinding(GameSettings.KEY_LOCK_ROTATION, () -> new KeyBindingComponent(GameSettings.KEY_LOCK_ROTATION))
+    );
+    public static final @NotNull HudComponentHeldItemCount HELD_ITEM_COUNT = register(
+        new HudComponentHeldItemCount("held_item_count", new LayoutSnap(HOTBAR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT))
+            .addAttachedOption(GameSettings.HIDE_HELD_ITEM_COUNT, () -> new BooleanOptionComponent(GameSettings.HIDE_HELD_ITEM_COUNT))
+            .addAttachedOption(GameSettings.VERTICAL_HELD_ITEM_COUNT, () -> new BooleanOptionComponent(GameSettings.VERTICAL_HELD_ITEM_COUNT))
+            .addAttachedOption(GameSettings.FLIP_HELD_ITEM_COUNT, () -> new BooleanOptionComponent(GameSettings.FLIP_HELD_ITEM_COUNT))
+    );
+
+    public static <T extends HudComponent> T register(T component) {
+        if(INSTANCE == null) throw new IllegalStateException("HudComponents not initialized, Instance is null");
         INSTANCE.components.add(component);
         return component;
     }
     private final List<HudComponent> components = new ArrayList<>();
 
-
-
     private HudComponents() { }
 
     public List<HudComponent> getComponents() {
         return this.components;
     }
 
-    public HudComponent getComponent(String key) {
+    public @Nullable HudComponent getComponent(String key) {
         for (HudComponent component : this.components) {
             if (component.getKey().equals(key)) {
                 return component;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
index 0ce40fc8e..b6da0e1e2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/layout/LayoutAbsolute.java
@@ -3,70 +3,72 @@ package net.minecraft.client.gui.hud.component.layout;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.hud.component.HudComponent;
 import net.minecraft.client.option.GameSettings;
+import org.jetbrains.annotations.NotNull;
 
-public class LayoutAbsolute
-    extends Layout {
+public class LayoutAbsolute extends Layout {
     private float xPosition;
     private float yPosition;
-    private ComponentAnchor anchor;
+    private @NotNull ComponentAnchor anchor;
+    private int xOffset;
+    private int yOffset;
 
-    public LayoutAbsolute(float xPosition, float yPosition, ComponentAnchor anchor) {
-        this.xPosition = xPosition;
-        this.yPosition = yPosition;
-        this.anchor = anchor;
-    }
-
-    public float getXPosition() {
-        return this.xPosition;
-    }
-
-    public float getYPosition() {
-        return this.yPosition;
-    }
-
-    public ComponentAnchor getAnchor() {
-        return this.anchor;
+    public LayoutAbsolute(float xPosition, float yPosition, @NotNull ComponentAnchor anchor) {
+        this(xPosition, yPosition, anchor, 0, 0);
     }
 
-    public void setXPosition(float xPosition) {
+    public LayoutAbsolute(float xPosition, float yPosition, @NotNull ComponentAnchor anchor, int xOffset, int yOffset) {
         this.xPosition = xPosition;
-    }
-
-    public void setYPosition(float yPosition) {
         this.yPosition = yPosition;
-    }
-
-    public void setAnchor(ComponentAnchor anchor) {
         this.anchor = anchor;
+        this.xOffset = xOffset;
+        this.yOffset = yOffset;
     }
 
+    public float getXPosition() { return this.xPosition; }
+    public float getYPosition() { return this.yPosition; }
+    public @NotNull ComponentAnchor getAnchor() { return this.anchor; }
+    public int getXOffset() { return this.xOffset; }
+    public int getYOffset() { return this.yOffset; }
+
+    public void setXPosition(float xPosition) { this.xPosition = xPosition; }
+    public void setYPosition(float yPosition) { this.yPosition = yPosition; }
+    public void setAnchor(@NotNull ComponentAnchor anchor) { this.anchor = anchor; }
+    public void setXOffset(int xOffset) { this.xOffset = xOffset; }
+    public void setYOffset(int yOffset) { this.yOffset = yOffset; }
+
     @Override
-    public int getComponentX(HudComponent component, int xSizeScreen) {
-        int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-        return (int) (this.xPosition * xSizeScreen) - component.getAnchorX(this.anchor) + sp;
+    public int getComponentX(@NotNull HudComponent component, int xSizeScreen) {
+        return (int) (this.xPosition * xSizeScreen) - component.getTrueAnchorX(this.anchor) + this.xOffset;
     }
 
     @Override
-    public int getComponentY(HudComponent component, int ySizeScreen) {
-        int sp = (int) (GameSettings.SCREEN_PADDING.value * mc.resolution.getScaledHeightScreenCoords() / 8);
-        return (int) (this.yPosition * ySizeScreen) - component.getAnchorY(this.anchor) + sp;
+    public int getComponentY(@NotNull HudComponent component, int ySizeScreen) {
+        return (int) (this.yPosition * ySizeScreen) - component.getTrueAnchorY(this.anchor) + this.yOffset;
     }
 
     @Override
-    public Layout copy() {
-        return new LayoutAbsolute(this.xPosition, this.yPosition, this.anchor);
+    public @NotNull Layout copy() {
+        return new LayoutAbsolute(this.xPosition, this.yPosition, this.anchor, this.xOffset, this.yOffset);
     }
 
     @Override
-    public String toSettingsString() {
-        return this.xPosition + "," + this.yPosition + "," + this.anchor.name();
+    public @NotNull String toSettingsString() {
+        return this.xPosition + "," + this.yPosition + "," + this.anchor.name() + "," + this.xOffset + "," + this.yOffset;
     }
 
     @Override
-    public void fromSettingsString(String settings) {
+    public void fromSettingsString(@NotNull String settings) {
         String[] parts = settings.split(",");
         this.xPosition = Float.parseFloat(parts[0]);
         this.yPosition = Float.parseFloat(parts[1]);
         this.anchor = ComponentAnchor.valueOf(parts[2]);
+
+        if (parts.length > 3) {
+            this.xOffset = Integer.parseInt(parts[3]);
+            this.yOffset = Integer.parseInt(parts[4]);
+        } else {
+            this.xOffset = 0;
+            this.yOffset = 0;
+        }
     }
-}
+}
\ No newline at end of file
